 
def loadConversionTable(filename):
    f = open(filename)
    table = {}
    for r in f:
        data = r.split()
        if not table.has_key(data[0]):
            table[data[0]] = []
        table[data[0]].append(data[1])
    return table
            

def generateMutants(sequence, conversion_table):
    mutants = []
    for i in range(len(sequence)):
        res = sequence[i].lower()
        if not conversion_table.has_key(res):
            continue            
        for mut in conversion_table[res]:
            mutants.append(sequence[:i] + mut + sequence[i+1:])
    return mutants
            
def printMutants(mutants):
    print "\n".join(mutants)

def generateSPMMutants(sequence, conversion_table_file):
    conversion_table = loadConversionTable(conversion_table_file)
    mutants = generateMutants(sequence, conversion_table)
    printMutants(mutants)
    
    
generateSPMMutants("AFDREEHYN", "conversion_table")
